/*
  Whetzel Thornsbury
  Expert Systems Research Project

  Unfortunately I could not find SWI-cpp.h on this server, which has
  the direct hooks into SWI-prolog through C++.  Had to use C++ to basically
  open an instance of Prolog and execute a predicate.

  Compile using plld -o tires tires.cpp tires.pl
  A conventional makefile would not work with the way it was programmed.

  Knowledge base was verified using a stand alone SWI-Prolog install on my
  personal computer.
*/


#include <iostream>
#include <cstring>
#include "/usr/local/lib/pl-5.6.62/include/SWI-Prolog.h"

int main(int argc, char **argv)
{
  if ( ! PL_initialise(argc, argv)){
    std::cout << "error initializing" << "\n";
    PL_halt(1);
  }
  else
  {
    std::cout << "success initialization!" << "\n";
  }

  static predicate_t pred = PL_predicate("tire_problem", 2, "user");
  term_t h0;
  h0 = PL_new_term_refs(2);

  int rval;
  PL_put_atom_chars(h0, argv[0]);
  rval = PL_call_predicate(NULL, PL_Q_NORMAL, pred, h0);

  PL_halt( rval ? 0 : 1 );
  return 0;

}
